      PROGRAM CHECK

********************************************************************
*                                                                  *
*                     Author: A. BECK                              *
*                     2003-05-26                                   *
*                                                                  *
********************************************************************

      INTEGER I,J,K,L,JPACK,JPUNP,IFIELD,IWORD
      INTEGER INDE,LUNIT,LENGHT,levtotal,LEV,LEVMIN,LEVMAX

      INTEGER ISEC0(2),JSEC0(2)
      INTEGER ISEC1(56),JSEC1(56)

      INTEGER, ALLOCATABLE, DIMENSION (:) :: ISEC2,JSEC2

      INTEGER ISEC3(2),JSEC3(2)
      INTEGER ISEC4(64),JSEC4(64)
      
      REAL, ALLOCATABLE, DIMENSION (:) ::  ZSEC2,YSEC2

      REAL ZSEC3(2),YSEC3(2)
      
      INTEGER, ALLOCATABLE, DIMENSION (:) :: INBUFF

      REAL, ALLOCATABLE, DIMENSION (:) :: ZSEC4
 
      CHARACTER*1 YOPER
      integer ierr

      integer maxl, maxb, mlevel, levout, mnauf
      real rlo0, rlo1, rla0, rla1

      INTEGER MAUF, MANF,meta,metadiff
      
      integer npar
      parameter(npar=15)

      character*4 ccheck(npar)
      integer icheck(npar)

      data ccheck /"T","U","V","Q","LNSP","DETA","LSP","CP","SSHF",
     1     "SSR","EWSS","NSSS","OMEG","OMD","PTEN"/      

      NAMELIST /NAMGEN/
     1            MAXL, MAXB,
     2            MLEVEL,LEVOUT,LEVMIN,LEVMAX,
     3            MNAUF,
     4            RLO0, RLO1, RLA0, RLA1,
     5            MOMEGA,MOMEGADIFF,MGAUSS,MSMOOTH,META,METADIFF

      call posnam (4,'NAMGEN')
      read (4,NAMGEN)

      MAUF=INT(360.*(REAL(MAXL)-1.)/(RLO1-RLO0))

      MANF=INT(REAL(MAUF)/360.*(360.+RLO0)+1.)

      JPACK=4*MAXL*MAXB
      JPUNP=4*JPACK

*******************************************************************
*     GRIB STUFF *
*******************************************************************

      ALLOCATE (ISEC2(22+MAXL+MAXB),JSEC2(22+MAXL+MAXB))

      ALLOCATE (ZSEC2(60+2*MLEVEL),YSEC2(60+2*MLEVEL))

      ALLOCATE (INBUFF(JPACK))

      ALLOCATE (ZSEC4(JPUNP))

      icheck(:) = 0

*
* OPENING OF UNBLOCKED GRIB FILE
*
      call PBOPEN(LUNIT,'fort.15','r',IERR)
      if(ierr.lt.0) stop ' SUBROUTINE PBOPEN: ERROR OPENING fort.15'
      ifield=0
 50   ifield=ifield+1

*
*     Get next product
*
      call PBGRIB(LUNIT,INBUFF,JPACK*8,LENGHT,IERR)
      if(ierr.eq.-1) goto 200   ! EOF detected
      if(ierr.lt.-1) stop 'SORRY: GRIB READ ERROR DETECTED'
      if(ierr.ne.0) stop 'SORRY: GRIB READ ERROR DETECTED'

      YOPER = 'D'
      IERR = 1

*
* PARAMETERS NEEDED FOR ROUTINE GRIBEX: SEE DESCRIPTION
*
      CALL GRIBEX (ISEC0,ISEC1,ISEC2,ZSEC2,ISEC3,ZSEC3,ISEC4,
     C             ZSEC4,JPUNP,INBUFF,JPACK,IWORD,YOPER,IERR)
*
      IF (IERR.NE.0) STOP 'SORRY: GRIB CODE CONVERSION ERROR'

      if(isec1(6).eq.130) icheck(1)=icheck(1)+1
      if(isec1(6).eq.131) icheck(2)=icheck(2)+1
      if(isec1(6).eq.132) icheck(3)=icheck(3)+1
      if(isec1(6).eq.133) icheck(4)=icheck(4)+1
      if(isec1(6).eq.134) icheck(5)=icheck(5)-1
      if(isec1(6).eq.135) icheck(6)=icheck(6)+1
      if(isec1(6).eq.142) icheck(7)=icheck(7)-1
      if(isec1(6).eq.143) icheck(8)=icheck(8)-1
      if(isec1(6).eq.146) icheck(9)=icheck(9)-1
      if(isec1(6).eq.176) icheck(10)=icheck(10)-1
      if(isec1(6).eq.180) icheck(11)=icheck(11)-1
      if(isec1(6).eq.181) icheck(12)=icheck(12)-1
      if(isec1(6).eq.137) icheck(13)=icheck(13)+1
      if(isec1(6).eq.138) icheck(14)=icheck(14)+1
      if(isec1(6).eq.136) icheck(15)=icheck(15)-1

      GO TO 50
 200  CALL PBCLOSE(LUNIT,IERR)

*
* OPENING OF UNBLOCKED GRIB FILE
*
      IF(MOMEGADIFF .NE. 0 .OR. MOMEGA .NE. 0) THEN
        call PBOPEN(LUNIT,'fort.25','r',IERR)
        if(ierr.lt.0) stop ' SUBROUTINE PBOPEN: ERROR OPENING fort.25'
        ifield=0
 250    ifield=ifield+1

*
*     Get next product
*
        call PBGRIB(LUNIT,INBUFF,JPACK*8,LENGHT,IERR)
        if(ierr.eq.-1) goto 300   ! EOF detected
        if(ierr.lt.-1) stop 'SORRY: GRIB READ ERROR DETECTED'
        if(ierr.ne.0) stop 'SORRY: GRIB READ ERROR DETECTED'

        YOPER = 'D'
        IERR = 1

*
* PARAMETERS NEEDED FOR ROUTINE GRIBEX: SEE DESCRIPTION
*
        CALL GRIBEX (ISEC0,ISEC1,ISEC2,ZSEC2,ISEC3,ZSEC3,ISEC4,
     C             ZSEC4,JPUNP,INBUFF,JPACK,IWORD,YOPER,IERR)
*
        IF (IERR.NE.0) STOP 'SORRY: GRIB CODE CONVERSION ERROR'

        if(isec1(6).eq.137) icheck(13)=icheck(13)+1
        if(isec1(6).eq.138) icheck(14)=icheck(14)+1
        if(isec1(6).eq.136) icheck(15)=icheck(15)-1
!
        GO TO 250
 300    CALL PBCLOSE(LUNIT,IERR)

      ENDIF

 310  IERR = 0

*
* OPENING OF ETADOT FILE
*
      IF(METADIFF .NE. 0 .AND. META .NE. 0) THEN
        call PBOPEN(LUNIT,'fort.26','r',IERR)
        if(ierr.lt.0) stop ' SUBROUTINE PBOPEN: ERROR OPENING fort.26'
        ifield=0
 350    ifield=ifield+1

*
*     Get next product
*
        call PBGRIB(LUNIT,INBUFF,JPACK*8,LENGHT,IERR)
        if(ierr.eq.-1) goto 400   ! EOF detected
        if(ierr.lt.-1) stop 'SORRY: GRIB READ ERROR DETECTED'
        if(ierr.ne.0) stop 'SORRY: GRIB READ ERROR DETECTED'

        YOPER = 'D'
        IERR = 1

*
* PARAMETERS NEEDED FOR ROUTINE GRIBEX: SEE DESCRIPTION
*
        CALL GRIBEX (ISEC0,ISEC1,ISEC2,ZSEC2,ISEC3,ZSEC3,ISEC4,
     C             ZSEC4,JPUNP,INBUFF,JPACK,IWORD,YOPER,IERR)
*
        IF (IERR.NE.0) STOP 'SORRY: GRIB CODE CONVERSION ERROR'

!        if(isec1(6).eq.137) icheck(13)=icheck(13)+1
!        if(isec1(6).eq.138) icheck(14)=icheck(14)+1
!        if(isec1(6).eq.136) icheck(15)=icheck(15)-1

        GO TO 350
 400    CALL PBCLOSE(LUNIT,IERR)

      ENDIF

 410  IERR = 0

      print*,npar,momegadiff,momega
      do i = 1, npar-2*(1-MOMEGADIFF)-(1-MOMEGA)
         if (icheck(i) .eq. -1) then
             write (*,9905) ccheck(i), abs(icheck(i))
         elseif (icheck(i) .ge. 1 .and.
     * icheck(i) .eq. levmax-levmin+1) then
            write (*,9900) ccheck(i), icheck(i), levmax-levmin+1
         else
            write (*,9910) ccheck(i), icheck(i)
            IERR = IERR + 1
         endif
      enddo

      if (IERR .eq. 0) then
         open(12,file='CHECK.SUCCESS')
         write (12,*) 'CHECK FINISHED SUCCESSFULLY'
         close(12)
      else
         print*, 'CHECK FAILED !!!'
         STOP
      endif

 9900 FORMAT (' >> CHECK: parameter, nr level(s): ',
     2        A5,2x,I3.2,' expected: ',I3.2,' OK')

 9905 FORMAT (' >> CHECK: parameter, nr level(s): ',
     2        A5,2x,I3.2,' OK')

 9910 FORMAT (' >> CHECK: parameter, nr level(s): ',
     2        A5,2x,I3.2,' FAILED')

      END
      
